/* eslint-disable no-magic-numbers */
import mapNewReactionToReaction from '@/utils/reaction/mapNewReactionToReaction';

describe('mapNewReactionToReaction', () => {
  const newReaction = {
    id: 31141,
    notes: '',
    idReaction: 're22',
    name: '',
    reversible: false,
    symbol: null,
    abbreviation: null,
    formula: null,
    mechanicalConfidenceScore: null,
    lowerBound: null,
    upperBound: null,
    subsystem: null,
    geneProteinReaction: null,
    visibilityLevel: '',
    z: 45,
    synonyms: [],
    model: 137,
    kinetics: null,
    line: {
      id: 109668,
      width: 1,
      color: {
        alpha: 255,
        rgb: -16777216,
      },
      z: 0,
      segments: [
        {
          x1: 149.31765717927775,
          y1: 319.13724818355684,
          x2: 142.5553586937381,
          y2: 314.86275181644316,
        },
      ],
      startArrow: {
        arrowType: 'NONE',
        angle: 2.748893571891069,
        lineType: 'SOLID',
        length: 15,
      },
      endArrow: {
        arrowType: 'NONE',
        angle: 2.748893571891069,
        lineType: 'SOLID',
        length: 15,
      },
      lineType: 'SOLID',
    },
    processCoordinates: null,
    modifiers: [],
    products: [
      {
        id: 85169,
        line: {
          id: 109670,
          width: 1,
          color: {
            alpha: 255,
            rgb: -16777216,
          },
          z: 0,
          segments: [
            {
              x1: 142.5553586937381,
              y1: 314.86275181644316,
              x2: 122.2063492063492,
              y2: 302,
            },
          ],
          startArrow: {
            arrowType: 'NONE',
            angle: 2.748893571891069,
            lineType: 'SOLID',
            length: 15,
          },
          endArrow: {
            arrowType: 'OPEN',
            angle: 2.748893571891069,
            lineType: 'SOLID',
            length: 15,
          },
          lineType: 'SOLID',
        },
        stoichiometry: null,
        element: 58886,
      },
    ],
    reactants: [
      {
        id: 85168,
        line: {
          id: 109669,
          width: 1,
          color: {
            alpha: 255,
            rgb: -16777216,
          },
          z: 0,
          segments: [
            {
              x1: 169.66666666666666,
              y1: 332,
              x2: 149.31765717927775,
              y2: 319.13724818355684,
            },
          ],
          startArrow: {
            arrowType: 'NONE',
            angle: 2.748893571891069,
            lineType: 'SOLID',
            length: 15,
          },
          endArrow: {
            arrowType: 'NONE',
            angle: 2.748893571891069,
            lineType: 'SOLID',
            length: 15,
          },
          lineType: 'SOLID',
        },
        stoichiometry: null,
        element: 58872,
      },
    ],
    operators: [],
    elementId: 're22',
    references: [],
    sboTerm: 'SBO:0000171',
  };
  const expectedReaction = {
    centerPoint: {
      x: 0,
      y: 0,
    },
    hierarchyVisibilityLevel: '',
    id: 31141,
    kineticLaw: null,
    lines: [
      {
        start: {
          x: 149.31765717927775,
          y: 319.13724818355684,
        },
        end: {
          x: 142.5553586937381,
          y: 314.86275181644316,
        },
        type: '',
      },
      {
        start: {
          x: 142.5553586937381,
          y: 314.86275181644316,
        },
        end: {
          x: 122.2063492063492,
          y: 302,
        },
        type: '',
      },
      {
        start: {
          x: 169.66666666666666,
          y: 332,
        },
        end: {
          x: 149.31765717927775,
          y: 319.13724818355684,
        },
        type: '',
      },
    ],
    modelId: 137,
    modifiers: [],
    name: '',
    notes: '',
    products: [],
    reactants: [],
    reactionId: 're22',
    references: [],
    type: 'Positive influence',
  };

  it('should return correct reaction object from new reaction object', () => {
    const result = mapNewReactionToReaction(newReaction);
    expect(result).toEqual(expectedReaction);
  });
});
